/////////////////////////////////////////////////////////////////////////////// //
// $Id: BasicDeviceRegistry.cxx,v 1.1 1994/02/18 19:48:47 bmott Exp $
/////////////////////////////////////////////////////////////////////////////// //
// BasicDeviceRegistry.cxx
//
//   This abstract base class is used to derive a class that maintains a list
// of al the device in the simulator and allows them to be created.
//
//
// BSVC "A Microprocessor Simulation Framework"
// Copyright (c) 1993
// By: Bradford W. Mott
// October 30,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: BasicDeviceRegistry.cxx,v $
// Revision 1.1  1994/02/18  19:48:47  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#include "BasicCPU.hxx"
#include "BasicDevice.hxx"
#include "BasicDeviceRegistry.hxx"

///////////////////////////////////////////////////////////////////////////////
// Get the device information with the given index (return 1=OK,0=ERROR)
///////////////////////////////////////////////////////////////////////////////
int BasicDeviceRegistry::Information(int i, DeviceInformation &info)
{
  if (i<number_of_devices)
  {
    info=devices[i];
    return(1);
  }
  else
  {
    return(0);
  } 
}

