///////////////////////////////////////////////////////////////////////////////
// $Id: BasicLoader.hxx,v 1.1 1994/02/18 19:49:06 bmott Exp $
///////////////////////////////////////////////////////////////////////////////
// BasicLoader.hxx
//
//   This abstract base class provides methods to load object files into the
// the simulator.
//
//
// BSVC "A Microprocessor Simulation Framework"
// Copyright (c) 1993
// By: Bradford W. Mott
// November 5,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: BasicLoader.hxx,v $
// Revision 1.1  1994/02/18  19:49:06  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#ifndef BASICLOADER_HXX
#define BASICLOADER_HXX

#include "String.h"

class BasicCPU;

///////////////////////////////////////////////////////////////////////////////
// BasicLoader class declaration
///////////////////////////////////////////////////////////////////////////////
class BasicLoader {
  protected:
    BasicCPU*   cpu;
                                                
  public:
    BasicLoader(BasicCPU* c)
        : cpu(c)
    {};

    virtual ~BasicLoader()
    {};

    // Return the loader's CPU
    inline BasicCPU* CPU()
    { return(cpu); }

    // Load the file (Error Message or "" is returned)
    virtual String Load(const char *filename, int space)=0;
};
#endif

