///////////////////////////////////////////////////////////////////////////////
// $Id: BreakpointList.hxx,v 1.1 1994/02/18 19:49:26 bmott Exp $
///////////////////////////////////////////////////////////////////////////////
// BreakpointList.hxx 
//
//   This class manages a list of breakpoints
//
//
// BSVC "A Microprocessor Simulation Framework"
// Copyright (c) 1993
// By: Bradford W. Mott
// November 23,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: BreakpointList.hxx,v $
// Revision 1.1  1994/02/18  19:49:26  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#ifndef BREAKPOINTLIST_HXX
#define BREAKPOINTLIST_HXX

class BreakpointList {
  private:
    // Structure for linked list of breakpoints
    struct BreakpointNode {
      unsigned long address;
      BreakpointNode  *next;
    };

    // Head of the linked list
    BreakpointNode *head;

    // Tail of the linked list
    BreakpointNode *tail;

  public:
    BreakpointList();

    // Add a break point to the list
    void Add(unsigned long address);

    // Delete a break point from the list (1=OK,0=ERROR)
    int Delete(unsigned long address);

    // Return the number of breakpoints
    int NumberOfBreakpoints();

    // Get the break point with the given index (1=OK,0=ERROR)
    int GetBreakpoint(unsigned int index, unsigned long& address);

    // Check to see if the given address is a breakpoint (1=YES,0=NO)
    int Check(unsigned long address);
};
#endif
