///////////////////////////////////////////////////////////////////////////////
// $Id: Tools.hxx,v 1.1 1994/02/18 19:54:18 bmott Exp $
///////////////////////////////////////////////////////////////////////////////
//
// Tools.hxx - This is a collection of useful routines 
//
//   unsigned int StringToInt(String &);
//   String& IntToString(unsigned int value, int size, int field_width);
//
//
// BSVC "A Microprocessor Simulation Framework"
// Copyright (c) 1993
// By: Bradford W. Mott
// November 6,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: Tools.hxx,v $
// Revision 1.1  1994/02/18  19:54:18  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#ifndef TOOLS_HXX
#define TOOLS_HXX

#include "String.h"

///////////////////////////////////////////////////////////////////////////////
// Convert the string to an unsigned integer
///////////////////////////////////////////////////////////////////////////////
unsigned int StringToInt(String);

///////////////////////////////////////////////////////////////////////////////
// Convert the value to a string of width padded with zeros
///////////////////////////////////////////////////////////////////////////////
String IntToString(unsigned int value, int width);

///////////////////////////////////////////////////////////////////////////////
// Convert the value to a decimal string padded with spaces
///////////////////////////////////////////////////////////////////////////////
String IntToDecimal(unsigned long value, int width);

#endif
