/////////////////////////////////////////////////////////////////////////////// //
// $Id: DeviceRegistry.hxx,v 1.1 1994/02/18 20:11:56 bmott Exp $
/////////////////////////////////////////////////////////////////////////////// //
// DeviceRegistry.hxx
//
//   This class keeps up with a list of all of the availible devices and
// allocates them.  It's dervied from the BasicDeviceRegistry
//
// Sim68000 "Motorola 68000 Simulator"
// Copyright (c) 1993
// By: Bradford W. Mott
// October 30,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: DeviceRegistry.hxx,v $
// Revision 1.1  1994/02/18  20:11:56  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#ifndef DEVICEREGISTRY_HXX
#define DEVICEREGISTRY_HXX

#include "BasicDeviceRegistry.hxx"

///////////////////////////////////////////////////////////////////////////////
// The DeviceRegistry Class
///////////////////////////////////////////////////////////////////////////////
class DeviceRegistry : public BasicDeviceRegistry {
  private:
    static const DeviceInformation device_info[];

  public:
    DeviceRegistry();

    // Create a device with the given name (return 1=OK,0=ERROR)
    int Create(String& name, String& args, BasicCPU *,
               BasicDevice* &device); 
};
#endif
