/////////////////////////////////////////////////////////////////////////////// //
// $Id: Loader.hxx,v 1.1 1994/02/18 20:19:08 bmott Exp $
/////////////////////////////////////////////////////////////////////////////// //
// Loader.hxx
//
// Load object files
//
// Sim68000 "Motorola 68000 Simulator"
// Copyright (c) 1993
// By: Bradford W. Mott
// November 5,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: Loader.hxx,v $
// Revision 1.1  1994/02/18  20:19:08  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#ifndef LOADER_HXX
#define LOADER_HXX

#include <iostream.h>
#include <fstream.h>

#include "BasicLoader.hxx"

///////////////////////////////////////////////////////////////////////////////
// The Loader Class
///////////////////////////////////////////////////////////////////////////////
class Loader : public BasicLoader {
  private:
    // Load in a Motorola S-Record file
    String LoadMotorolaSRecord(fstream& file, int space);

  public:
    Loader(BasicCPU* c)
        : BasicLoader(c)
    {};

    // Load the file into the addr space (Error Message or "" is returned)
    String Load(const char *filename, int space);
};

#endif
