///////////////////////////////////////////////////////////////////////////////
// $Id: main.cxx,v 1.2 1994/08/22 07:33:55 bmott Exp $
///////////////////////////////////////////////////////////////////////////////
// main.cxx 
//
//   The main procedure has to instantiate all of the objects and startup the
// user interface command parser
//
// Sim68000 "Motorola 68000 Simulator"
// Copyright (c) 1993
// By: Bradford W. Mott
// Novemeber 13,1993
//
///////////////////////////////////////////////////////////////////////////////
// $Log: main.cxx,v $
// Revision 1.2  1994/08/22  07:33:55  bmott
// Modified include statements and change UICommand to Interface
//
// Revision 1.1  1994/02/18  19:59:12  bmott
// Initial revision
//
///////////////////////////////////////////////////////////////////////////////

#include "Interface.hxx"
#include "cpu/m68000.hxx"
#include "devices/DeviceRegistry.hxx"
#include "loader/Loader.hxx"


main()
{
 AddressSpace*        addr_space = new AddressSpace(0x00ffffff);
 BasicCPU*            processor  = new m68000(addr_space);
 BasicLoader*         loader     = new Loader(processor);
 BasicDeviceRegistry* registry   = new DeviceRegistry;

 Interface interface(processor, registry, loader);
 interface.CommandLoop();

 delete registry;
 delete loader;
 delete processor;
 delete addr_space;
}

